/*
	colors.h 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

static struct color color_options[]={
{"NOTHING","#ffffff",0},
{"aliceblue","#f0f8ff",1},
{"antiqueWhite","#faebd7",2},
{"aqua","#00ffff",3},
{"aquamarine","#7fffd4",4},
{"azure","#f0ffff",5},
{"beige","#f5f5dc",6},
{"bisque","#ffe4c4",7},
{"black","#000000",8},
{"blanchedalmond","#ffebcd",9},
{"blue","#0000ff",10},
{"blueViolet","#8a2be2",11},
{"brown","#a52a2a",12},
{"burlyWood","#deb887",13},
{"cadetblue","#5f9ea0",14},
{"chartreuse","#7fff00",15},
{"chocolate","#d2691e",16},
{"coral","#ff7f50",17},
{"cornflowerblue","#6495ed",18},
{"cornsilk","#fff8dc",19},
{"crimson","#dc143c",20},
{"cyan","#00ffff",21},
{"darkblue","#00008b",22},
{"darkcyan","#008b8b",23},
{"darkGoldenRod","#b8860b",24},
{"darkGray","#a9a9a9",25},
{"darkGreen","#006400",26},
{"darkKhaki","#bdb76b",27},
{"darkMagenta","#8b008b",28},
{"darkOliveGreen","#556b2f",29},
{"darkorange","#ff8c00",30},
{"darkOrchid","#9932cc",31},
{"darkRed","#8b0000",32},
{"darkSalmon","#e9967a",33},
{"darkSeaGreen","#8fbc8f",34},
{"darkSlateblue","#483d8b",35},
{"darkSlateGray","#2f4f4f",36},
{"darkTurquoise","#00ced1",37},
{"darkViolet","#9400d3",38},
{"deepPink","#ff1493",39},
{"deepSkyblue","#00bfff",40},
{"dimGray","#696969",41},
{"dodgerblue","#1e90ff",42},
{"feldspar","#d19275",43},
{"firebrick","#b22222",44},
{"floralWhite","#fffaf0",45},
{"forestGreen","#228b22",46},
{"fuchsia","#ff00ff",47},
{"Gainsboro","#dcdcdc",48},
{"GhostWhite","#f8f8ff",49},
{"Gold","#ffd700",50},
{"GoldenRod","#daa520",51},
{"Gray","#808080",52},
{"Green","#008000",53},
{"GreenYellow","#adff2f",54},
{"Honeydew","#f0fff0",55},
{"HotPink","#ff69b4",56},
{"IndianRed","#cd5c5c",57},
{"Indigo","#4b0082",58},
{"Ivory","#fffff0",59},
{"Khaki","#f0e68c",60},
{"Lavender","#e6e6fa",61},
{"Lavenderblush","#fff0f5",62},
{"LawnGreen","#7cfc00",63},
{"Lemonchiffon","#fffacd",64},
{"Lightblue","#add8e6",65},
{"Lightcoral","#f08080",66},
{"Lightcyan","#e0ffff",67},
{"LightGoldenRodYellow","#fafad2",68},
{"LightGrey","#d3d3d3",69},
{"LightGreen","#90ee90",70},
{"LightPink","#ffb6c1",71},
{"LightSalmon","#ffa07a",72},
{"LightSeaGreen","#20b2aa",73},
{"LightSkyblue","#87cefa",74},
{"LightSlateblue","#8470ff",75},
{"LightSlateGray","#778899",76},
{"LightSteelblue","#b0c4de",77},
{"LightYellow","#ffffe0",78},
{"Lime","#00ff00",79},
{"LimeGreen","#32cd32",80},
{"Linen","#faf0e6",81},
{"Magenta","#ff00ff",82},
{"Maroon","#800000",83},
{"MediumaquaMarine","#66cdaa",84},
{"Mediumblue","#0000cd",85},
{"MediumOrchid","#ba55d3",86},
{"MediumPurple","#9370d8",87},
{"MediumSeaGreen","#3cb371",88},
{"MediumSlateblue","#7b68ee",89},
{"MediumSpringGreen","#00fa9a",90},
{"MediumTurquoise","#48d1cc",91},
{"MediumVioletRed","#c71585",92},
{"Midnightblue","#191970",93},
{"Mintcream","#f5fffa",94},
{"MistyRose","#ffe4e1",95},
{"Moccasin","#ffe4b5",96},
{"NavajoWhite","#ffdead",97},
{"Navy","#000080",98},
{"OldLace","#fdf5e6",99},
{"Olive","#808000",100},
{"Olivedrab","#6b8e23",101},
{"Orange","#ffa500",102},
{"OrangeRed","#ff4500",103},
{"Orchid","#da70d6",104},
{"PaleGoldenRod","#eee8aa",105},
{"PaleGreen","#98fb98",106},
{"PaleTurquoise","#afeeee",107},
{"PaleVioletRed","#d87093",108},
{"PapayaWhip","#ffefd5",109},
{"PeachPuff","#ffdab9",110},
{"Peru","#cd853f",111},
{"Pink","#ffc0cb",112},
{"Plum","#dda0dd",113},
{"Powderblue","#b0e0e6",114},
{"Purple","#800080",115},
{"Red","#ff0000",116},
{"Rosybrown","#bc8f8f",117},
{"Royalblue","#4169e1",118},
{"Saddlebrown","#8b4513",119},
{"Salmon","#fa8072",120},
{"Sandybrown","#f4a460",121},
{"SeaGreen","#2e8b57",122},
{"SeaShell","#fff5ee",123},
{"Sienna","#a0522d",124},
{"Silver","#c0c0c0",125},
{"Skyblue","#87ceeb",126},
{"Slateblue","#6a5acd",127},
{"SlateGray","#708090",128},
{"Snow","#fffafa",129},
{"SpringGreen","#00ff7f",130},
{"Steelblue","#4682b4",131},
{"Tan","#d2b48c",132},
{"Teal","#008080",133},
{"Thistle","#d8bfd8",134},
{"Tomato","#ff6347",135},
{"Turquoise","#40e0d0",136},
{"Violet","#ee82ee",137},
{"VioletRed","#d02090",138},
{"Wheat","#f5deb3",139},
{"White","#ffffff",140},
{"WhiteSmoke","#f5f5f5",141},
{"Yellow","#ffff00",142},
{"YellowGreen","#9acd32",143},
//ki colors.....
{"KIPLUM","#7f004d",144},//#96005A
{"KIGreenish","#7AFFCF",145},
{"KIGrey","#B5B5B5",146},
{"KILightGrey","#E6E6E6",147}

};



