/*
	msa_viewer_html_ouput.c 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include "msa_viewer.h"
#include "colors.h"

void feature_out(struct alignment* aln,int ann,char* type,int full_name_len,int pretty,int remove_allgap_columns)
{
	struct feature* n = 0;
	int i,j,c;
	int old_choice = -10000;
	int choice = 0;
	//int max = 0;
	int* isgap = 0;
	int newlen = 0;
	char * ladder = 0;
	int ingap = 0;
	char *tmp_note = 0;
	//for (j = 0; j< aln->numseq;j++){
	//	if( aln->si[j]->namel > max){
	//		max = aln->si[j]->namel;
	//	}
	//}
	
	isgap = tmalloc(sizeof(int)*aln->aln_len);
	for( i = aln->aln_len;i--;){
		isgap[i] = 1;
	}
	
	if(remove_allgap_columns){
	for (i = 0; i < aln->aln_len;i++){
		for (j = 0; j < aln->numseq;j++){
			if(isalpha((int)aln->si[j]->s[i])){
				isgap[i] = 0; 
				newlen++;
				break;
			}
		}
	}	
	}else{
		for( i = aln->aln_len;i--;){
			isgap[i] = 0;
		}
		newlen = aln->aln_len;
	}
			
	fprintf(stdout,"<xml id=\"xmlsrc%d\" style=\"display:none;\">\n",ann);
	fprintf(stdout,"<macsim>");
	fprintf(stdout,"<laddername>");
	fprintf(stdout,"LADDER");
	for(i = 5; i< full_name_len;i++){
		fprintf(stdout," ");
	}
	fprintf(stdout,"</laddername>");
	fprintf(stdout,"<ladder>");
	ladder = print_ladder(ladder,newlen);
	j = 0;
	for (i = 0; i< newlen;i++){
		
		if(j == 100){
			fprintf(stdout,"</ladder>");
			fprintf(stdout,"<ladder>");
			j = 0;
		}
		fprintf(stdout,"%c",ladder[i]);
		j++;
	}
	fprintf(stdout,"</ladder>");
	fprintf(stdout,"<alignment><aln-name>kalign alignment</aln-name>");
	
	for (i = 0;i < aln->numseq;i++){
		//n = aln->tf[i];
	//	fprintf(stdout,"<sequence seq-type=\"Protein\"><seq-name>%s</seq-name><seq-data><g><r>",aln->sn[i]);
		fprintf(stdout,"<sequence seq-type=\"Protein\"><seq-name>%s</seq-name><seq-data><g><r>",aln->si[i]->name);
		c = 0;
		ingap = 0;
		
		for (j = 0;j < aln->aln_len;j++){
			if(!isgap[j]){
			choice = aln->ann[i][j];
			//fprintf(stderr,"%d\n",choice);
			if (old_choice != choice){
	//			n = aln->ft[i];
				n = aln->si[i]->ft;
				while(n){
					
					if(check_identity(n->type,type)!=-1){
					if(n->rel_start == j &&n->color == choice ){
					//if(n->color == choice){
					//fprintf(stderr,"%d	%d	TYPE:%s-%s\nFeature:%s\nappear on %d residues	%d\nCOLOR:%d\n",n->rel_start,n->rel_end,n->type,type,n->note,n->start,c,n->color);
						fprintf(stdout,"</r></g><g><c>%s</c><t>%s</t><r>",color_options[choice].hex_code,n->note);
						tmp_note = n->note;
						break;
					}
					}
					n = n->next;
				}		
				if(!n){
					fprintf(stdout,"</r></g><g><r>");
				}		
			}
			if(c > 1001){
				c = 0;
			//	fprintf(stdout,"</r></g><g><r>");
				fprintf(stdout,"</r></g><g><c>%s</c><r>",color_options[choice].hex_code);
			}
			c++;
	//		fprintf(stdout,"%c",aln->s[i][j]);
			if(pretty){
			if(isalpha(aln->si[i]->s[j])&& !ingap){

				fprintf(stdout,"%c",aln->si[i]->s[j]);
				ingap = 0;
			}else if(isalpha(aln->si[i]->s[j])&& ingap){
				fprintf(stdout,"</r></g><g><c>%s</c><t>%s</t><r>",color_options[choice].hex_code,tmp_note);
				fprintf(stdout,"%c",aln->si[i]->s[j]);
				ingap = 0;
			}else{
				fprintf(stdout,"</r></g><g><r>");
				fprintf(stdout,"%c",aln->si[i]->s[j]);
				ingap = 1;
			}

			}else{
				fprintf(stdout,"%c",aln->si[i]->s[j]);
			}
			old_choice = choice;
			
			
			}
		}
		fprintf(stdout,"</r></g></seq-data></sequence>");
		
		old_choice = -10000;
	}	
	fprintf(stdout,"</alignment></macsim></xml>");
	for (i = aln->numseq;i--;){
		free(aln->ann[i]);
	}
	free(aln->ann);
	aln->ann = 0;
	free(isgap);
	free(ladder);
}

void html_out(struct alignment* aln,int ann,int full_name_len,int remove_allgap_columns)
{
	struct feature *n = 0;
	int i,j,c;
	int old_choice = -10000;
	int choice = 0;
	int* isgap = 0;
	int newlen = 0;
	char* ladder = 0;
	
	
	/*for (j = 0; j< aln->numseq;j++){
		if( aln->si[j]->namel > max){
			max = aln->si[j]->namel;
		}
	}
	if(max > full_name_len){
		max = full_name_len;
	//	for (j = 0; j< aln->numseq;j++){
	//		 aln->si[j]->name[max] = 0;
	//	}
	}*/
	
	isgap = tmalloc(sizeof(int)*aln->aln_len);
	for( i = aln->aln_len;i--;){
		isgap[i] = 1;
	}
	
	if(remove_allgap_columns){
	for (i = 0; i < aln->aln_len;i++){
		for (j = 0; j < aln->numseq;j++){
			if(isalpha((int)aln->si[j]->s[i])){
				isgap[i] = 0; 
				newlen++;
				break;
			}
		}
	}
	}else{
		for( i = aln->aln_len;i--;){
			isgap[i] = 0;
		}
		newlen = aln->aln_len;
	}
	
	
	
	fprintf(stdout,"<xml id=\"xmlsrc%d\" style=\"display:none;\">\n",ann);
	fprintf(stdout,"<macsim>");
	fprintf(stdout,"<laddername>");
	fprintf(stdout,"LADDER");
	for(i = 5; i< full_name_len;i++){
		fprintf(stdout," ");
	}
	fprintf(stdout,"</laddername>");
	fprintf(stdout,"<ladder>");
	ladder = print_ladder(ladder, newlen);
	j = 0;
	for (i = 0; i< newlen;i++){
		
		if(j == 1000){
			fprintf(stdout,"</ladder>");
			fprintf(stdout,"<ladder>");
			j = 0;
		}
		fprintf(stdout,"%c",ladder[i]);
		j++;
	}
	fprintf(stdout,"</ladder>");
	fprintf(stdout,"<alignment><aln-name>kalign alignment</aln-name>");
	for (i = 0;i < aln->numseq;i++){
	//	fprintf(stdout,"<sequence seq-type=\"Protein\"><seq-name>%s</seq-name>\n",aln->sn[i]);
		fprintf(stdout,"<sequence seq-type=\"Protein\"><seq-name>%s</seq-name>",aln->si[i]->name);
	//	if(aln->ft[i]){
		fprintf(stdout,"<seq-info>");
		if(aln->si[i]->accession){
			fprintf(stdout,"<accession>%s</accession>",aln->si[i]->accession);
		}
		if(aln->si[i]->nid){
			fprintf(stdout,"<nid>%s</nid>",aln->si[i]->nid);
		}
		if(aln->si[i]->ec){
			fprintf(stdout,"<ec>%s</ec>",aln->si[i]->ec);
		}
		if(aln->si[i]->group){
			fprintf(stdout,"<group>%d</group>",aln->si[i]->group);
		}
	
	
		if(aln->si[i]->ft){
			
		
			fprintf(stdout,"<ftable>\n");
	//		n = aln->ft[i];
			n = aln->si[i]->ft;
			while(n){
				fprintf(stdout,"<fitem><ftype>%s</ftype><fstart>%d</fstart><fstop>%d</fstop><fnote>%s</fnote></fitem>\n",n->type,n->start,n->end,n->note);
				n = n->next;
			}
			fprintf(stdout,"</ftable>\n");
		}
		fprintf(stdout,"</seq-info>\n");
		
		fprintf(stdout,"<seq-data><g><r>");
		c = 0;
		for (j = 0;j < aln->aln_len;j++){
			if(!isgap[j]){
				choice = aln->ann[i][j];
				if (old_choice == choice){
		//			fprintf(stdout,"%c",aln->s[i][j]);
					fprintf(stdout,"%c",aln->si[i]->s[j]);
				}else{
					//fprintf(stdout,"</r></g>%s%c",start_tag[choice],aln->s[i][j]);
		//			fprintf(stdout,"</r></g><g><c>%s</c><r>%c",color_options[choice].hex_code,aln->s[i][j]);
					fprintf(stdout,"</r></g><g><c>%s</c><r>%c",color_options[choice].hex_code,aln->si[i]->s[j]);
				}
				old_choice = choice;
				if(c > 1001){
					c = 0;
					fprintf(stdout,"</r></g><g><r>");
				}
				c++;
			}
		}
		fprintf(stdout,"</r></g></seq-data></sequence>");
		old_choice = -10000;
	
	}	
	//print columns...
	for(i =0;i< aln->numcolumn;i++){
		fprintf(stdout,"<column-score>");
		fprintf(stdout,"<colsco-name>%s</colsco-name>",aln->ca[i]->name);
		fprintf(stdout,"<colsco-owner>%d</colsco-owner>",aln->ca[i]->owner);
		fprintf(stdout,"<colsco-type>int</colsco-type>");
		fprintf(stdout,"<colsco-data>");
		for (j = 0;j < aln->si[0]->sl;j++){
			fprintf(stdout,"%f	",aln->ca[i]->doublec[j]);
		}
		fprintf(stdout,"</colsco-data></column-score>");
	
	}
	
	
	fprintf(stdout,"</alignment></macsim></xml>");
	for (i = aln->numseq;i--;){
		free(aln->ann[i]);
	}
	free(aln->ann);
	aln->ann =0;
	free(isgap);
	free(ladder);
}



char* print_ladder(char* ladder, int len)
{
	int i,j;
	int c;
	int n = 0;
	ladder =tmalloc(sizeof(char)*len+1);
	for (i = 0; i< len;i++){
		ladder[i] = ' ';
	}
	ladder[len] = 0;
	

	int ticker[9];
	for (i = 0; i < 9;i++){
		ticker[i] = 0;
	}
	//fprintf(stderr,"LEN::::%d\n",len);
	for (i = 0; i< len-10;i+=10){
		j = 1;
		while(j){
			if(ticker[j] == 9){
				ticker[j] = 0;
				j++;
			}else{
				ticker[j]+= 1;
				break;
			}
		}
		n = 0;
		for (j = 9; j--;){
			if(ticker[j]){
				n = j+1;
				break;
			}
		}
		c = (i+10)-(n+1);
	//	fprintf(stderr,"Printing at:%d	'",c);
		for (j = n; j--;){
			ladder[c] = (char)(ticker[j]+48);
	//		fprintf(stderr,"%c",(char)(ticker[j]+48));
			c++;
		}
		ladder[c] = '|';
	//	fprintf(stderr,"%c'\n",'|');
	}
	//exit(0);
	return ladder;
}

/*
void viewertop(int size,int view,int full_name_len,char* crosslink)
{
	//<script src=\"viewer.js\">
	fprintf(stdout,"\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t<html style=\"background-color:#dfd4ca;\" ><head>\n\
	<script type=\"text/javascript\">\n\
	var menuwidth=0;\n\
	var offsetleft=0;\n\
	var offsettop= 0;\n\
	var offsetmenutop=0;\n\
	var ns4 = document.layers?1:0;\n\
	var ie4 = document.all?1:0;\n\
	var ns6 = document.getElementById&&!document.all?1:0;\n\
	var screen_width = screen.width;\n\
	function transformXMLData(size,style,src) {\n\
	\n\
	if(size){\n\
		var x = window.pageXOffset;\n\
		x =x/ document.form1.size.value * size;\n\
		var y = window.pageYOffset;\n\
		y =y/ document.form1.size.value * size;\n\
		document.form1.size.value = size;\n\
	}else{\n\
		size = document.form1.size.value;\n\
	}\n\
	if(src){\n\
		var x = window.pageXOffset;\n\
		var y = window.pageYOffset;\n\
		document.form1.xmlsrc.value = src;\n\
	}else{\n\
		src = document.form1.xmlsrc.value;\n\
	}\n\
	\n\
	if(ie4){\n\
		var xmlDoc=new ActiveXObject(\"Microsoft.XMLDOM\");\n\
		xmlDoc.async=\"false\";\n\
		xmlDoc.loadXML(document.getElementById(src).innerHTML);\n\
		var xsl = new ActiveXObject(\"MSXML2.FreeThreadedDomDocument.3.0\");\n\
		xsl.async = \"false\";\n\
		xsl.load(style);\n\
		var template = new ActiveXObject(\"MSXML2.XSLTemplate\");\n\
  		template.stylesheet = xsl;\n\
  		processor = template.createProcessor();\n\
		processor.input = xmlDoc;\n\
  		processor.addParameter(\"size\", size);\n\
  		processor.addParameter(\"namelen\", %d);\n\
  		processor.addParameter(\"crosslink\",\"%s\");\n\
  		processor.transform();\n\
		document.getElementById('xslTarget').innerHTML = processor.output;\n\
	}else{\
		if(document.implementation && document.implementation.createDocument) {\n\
			document.getElementById(\"doc\").removeChild(document.getElementById(\"xslTarget\"));\
			var n=document.createElement(\"div\");\n\
		    	n.setAttribute(\"id\",\"xslTarget\");\n\
		    	document.getElementById('doc').appendChild(n);\n\
			var myXMLHTTPRequest = new XMLHttpRequest();\n\
			myXMLHTTPRequest.open(\"GET\", style, false);\n\
			myXMLHTTPRequest.send(null);\n\
			xslStylesheet = myXMLHTTPRequest.responseXML;\n\
			var xsltProcessor = new XSLTProcessor();\n\
			xsltProcessor.importStylesheet(xsl);\n\
			xsltProcessor.setParameter(null, \"size\", size);\n\
			xsltProcessor.setParameter(null, \"namelen\", %d);\n\
			xsltProcessor.setParameter(null, \"crosslink\", \"%s\");\n\
			var xmlDoc = document.implementation.createDocument(\"\", \"\", null);\n\
			var myNode = document.getElementById(src);\n\
			var clonedNode = xmlDoc.importNode(myNode.childNodes.item(1), true);\n\
			xmlDoc.appendChild(clonedNode);\n\
			var resultDocument = xsltProcessor.transformToFragment(xmlDoc, document);\n\
			document.getElementById('xslTarget').appendChild(resultDocument);\n\
			\n\
		} else {\n\
			alert(\"UNKNOWN BROWSER\");\n\
			document.getElementById('xslTarget').innerHTML = 	xmlsrc.transformNode(document.getElementById('xslsrc').XMLDocument);\n\
		}\n\
		scroll(x,y);\n\
	}\n\
	}\n\
	\n\
	function forward1(format,src){\n\
		document.form1.xml.value = document.getElementById(src).innerHTML;\n\
		document.form1.format.value = format;\n\
		document.form1.submit();\n\
	}\n\
	\n\
	function forward3(src){\n\
		document.form3.inSeq.value = document.getElementById(src).innerHTML;\n\
		document.form3.size.value = document.form0.size.value;\n\
		document.form3.view.value = document.form2.view.value;\n\
		document.form3.view.value = document.form3.view.value.substring(6,7);\n\
		document.form3.submit();\n\
	}\n\
	\n\
	function makestatic() {\n\
		if (ie4) {\n\
			var el = document.getElementById('seqname');\n\
			var menu = document.getElementById('menu');\n\
			if(el){\n\
				seqname.style.pixelLeft=document.body.scrollLeft+offsetleft;\n\
				menu.style.pixelLeft=document.body.scrollLeft+offsetleft;\n\
				menu.style.pixelTop=document.body.scrollTop+offsetmenutop;\n\
			}\n\
		}else if (ns6) {\n\
			var el = document.getElementById('seqname');\n\
			var menu = document.getElementById('menu');\n\
			if(el){\n\
				document.getElementById('seqname').style.left=window.pageXOffset+offsetleft;\n\
				document.getElementById('menu').style.left=window.pageXOffset+offsetleft;\n\
				document.getElementById('menu').style.top=window.pageYOffset+offsetmenutop;\n\
			}\n\
		}else if (ns4) {\n\
			eval(document.seqname.left=eval(window.pageXOffset+offsetleft));\n\
		}\n\
		setTimeout('makestatic()',0);\n\
	}\n\
	\n\
	function menu3(){\n\
		if (ns6||ie4||ns4){\n\
			makestatic();\n\
			if (ie4) {\n\
				var el = document.getElementById('seqname');\n\
				var menu = document.getElementById('menu');\n\
				if(el){\n\
					seqname.style.pixelTop=document.body.scrollTop+offsettop;\n\
					menu.style.pixelTop=document.body.scrollTop+offsetmenutop;\n\
				}\n\
			}else if (ns6) {\n\
				var el = document.getElementById('seqname');\n\
				var menu = document.getElementById('menu');\n\
				if(el){\n\
					document.getElementById('seqname').style.top=window.pageYOffset+offsettop;\n\
					document.getElementById('menu').style.top=window.pageYOffset+offsetmenutop;\n\
				}\n\
			}else if (ns4) {\n\
				eval(document.seqname.top=eval(window.pageYOffset+offsettop));\n\
			}\n\
		}\n\
	}\n\
	\n\
	document.onload= menu3();\n\
	</script>\n\
	<style>\n\
	div.top{\n\
		position:absolute;\n\
		Z-Index:10;\n\
		width:100%%;\n\
		top: 0px;\n\
		left: 0px;\n\
		background-color:#e5e5e5;\n\
		\n\
	}\n\
	\n\
	div.top a {\n\
		color: #2b8ae9;\n\
		text-decoration: underline;\n\
	}\n\
	\n\
	div.top a:hover {\n\
		color: orange;\n\
	}\n\
	\n\
	</style>\n\
	</head><body id=\"doc\" onload=\"transformXMLData('%d','/viewer.xsl','xmlsrc%d')\">\n",full_name_len,crosslink,full_name_len,crosslink,size,view);
	
}*/

void viewertop(int size,int view,int full_name_len,char* crosslink)
{
	//<script src=\"viewer.js\">
	fprintf(stdout,"<html style=\"background-color:#dfd4ca;\" ><head>\n\
	<script>\n\
	var menuwidth=0;\n\
	var offsetleft=0;\n\
	var offsettop= 0;\n\
	var offsetmenutop=0;\n\
	var ns4 = document.layers?1:0;\n\
	var ie4 = document.all?1:0;\n\
	var ns6 = document.getElementById&&!document.all?1:0;\n\
	var screen_width = screen.width;\n\
	function transformXMLData(size,style,src) {\n\
		\n\
		if(size){\n\
			var x = window.pageXOffset;\n\
			x =x/ document.form1.size.value * size;\n\
			var y = window.pageYOffset;\n\
			y =y/ document.form1.size.value * size;\n\
			document.form1.size.value = size;\n\
		}else{\n\
			size = document.form1.size.value;\n\
		}\n\
		if(src){\n\
			var x = window.pageXOffset;\n\
			var y = window.pageYOffset;\n\
			document.form1.xmlsrc.value = src;\n\
		}else{\n\
			src = document.form1.xmlsrc.value;\n\
		}\n\
		\n\
		if(ie4){\n\
			var xmlDoc=new ActiveXObject(\"Microsoft.XMLDOM\");\n\
			xmlDoc.async=\"false\";\n\
			xmlDoc.loadXML(document.getElementById(src).innerHTML);\n\
			var xsl = new ActiveXObject(\"MSXML2.FreeThreadedDomDocument.3.0\");\n\
			xsl.async = \"false\";\n\
			xsl.load(style);\n\
			var template = new ActiveXObject(\"MSXML2.XSLTemplate\");\n\
			template.stylesheet = xsl;\n\
			processor = template.createProcessor();\n\
			processor.input = xmlDoc;\n\
			processor.addParameter(\"size\", size);\n\
			processor.addParameter(\"namelen\", %d);\n\
			processor.addParameter(\"crosslink\",\"%s\");\n\
			processor.transform();\n\
			document.getElementById('xslTarget').innerHTML = processor.output;\n\
		}else{\n\
			document.getElementById(\"doc\").removeChild(document.getElementById(\"xslTarget\"));\n\
			var n=document.createElement(\"div\");\n\
			n.setAttribute(\"id\",\"xslTarget\");\n\
			document.getElementById('doc').appendChild(n);\n\
			xmldoc=XML.getDataIsland(src);\n\
			xsl=loadXMLDoc(style);\n\
			xsltProcessor=new XSLTProcessor();\n\
			xsltProcessor.importStylesheet(xsl);\n\
			xsltProcessor.setParameter(null, \"size\", size);\n\
			xsltProcessor.setParameter(null, \"namelen\", %d);\n\
			xsltProcessor.setParameter(null, \"crosslink\", \"%s\");\n\
			resultDocument = xsltProcessor.transformToFragment(xmldoc,document);\n\
			document.getElementById(\"xslTarget\").appendChild(resultDocument);\n\
		}\n\
	}\n\
	\n\
	function loadXMLDoc(fname)\n\
	{\n\
		var xmlDoc;\n\
		xmlDoc=document.implementation.createDocument(\"\",\"\",null);\n\
		xmlDoc.async=false;\n\
		xmlDoc.load(fname);\n\
		return(xmlDoc);\n\
	}\n\
	XML.newDocument = function(rootTagName, namespaceURL) {\n\
		if (!rootTagName) rootTagName = \"\";\n\
		if (!namespaceURL) namespaceURL = \"\";\n\
		if (document.implementation && document.implementation.createDocument) {\n\
        		// This is the W3C standard way to do it\n\
			var xmlDoc=document.implementation.createDocument(namespaceURL,rootTagName, null);\n\
			xmlDoc.async=false;\n\
			return xmlDoc\n\
		}\n\
	};\n\
	\n\
	XML.getDataIsland = function(id) {\n\
		var doc;\n\
		doc = document.getElementById(id);\n\
		if (!doc.documentElement) {\n\
			var docelt = doc.firstChild;\n\
			while(docelt != null) {\n\
				if (docelt.nodeType == 1 /*Node.ELEMENT_NODE*/)\n\
				{\n\
					break;\n\
				}\n\
				docelt = docelt.nextSibling;\n\
			}\n\
			doc = XML.newDocument();\n\
			if (docelt)\n\
			{\n\
				doc.appendChild(doc.importNode(docelt, true));\n\
			}\n\
		}\n\
		return doc;\n\
	};\n\
	\n\
	function forward1(format,src){\n\
		document.form1.xml.value = document.getElementById(src).innerHTML;\n\
		document.form1.format.value = format;\n\
		document.form1.submit();\n\
	}\n\
	\n\
	function forward3(src){\n\
		document.form3.inSeq.value = document.getElementById(src).innerHTML;\n\
		document.form3.size.value = document.form0.size.value;\n\
		document.form3.view.value = document.form2.view.value;\n\
		document.form3.view.value = document.form3.view.value.substring(6,7);\n\
		document.form3.submit();\n\
	}\n\
	\n\
	function makestatic() {\n\
		if (ie4) {\n\
			var el = document.getElementById('seqname');\n\
			var menu = document.getElementById('menu');\n\
			if(el){\n\
				seqname.style.pixelLeft=document.body.scrollLeft+offsetleft;\n\
				menu.style.pixelLeft=document.body.scrollLeft+offsetleft;\n\
				menu.style.pixelTop=document.body.scrollTop+offsetmenutop;\n\
			}\n\
		}else if (ns6) {\n\
			var el = document.getElementById('seqname');\n\
			var menu = document.getElementById('menu');\n\
			if(el){\n\
				document.getElementById('seqname').style.left=window.pageXOffset+offsetleft;\n\
				document.getElementById('menu').style.left=window.pageXOffset+offsetleft;\n\
				document.getElementById('menu').style.top=window.pageYOffset+offsetmenutop;\n\
			}\n\
		}else if (ns4) {\n\
			eval(document.seqname.left=eval(window.pageXOffset+offsetleft));\n\
		}\n\
		setTimeout('makestatic()',0);\n\
	}\n\
	\n\
	function menu3(){\n\
		if (ns6||ie4||ns4){\n\
			makestatic();\n\
			if (ie4) {\n\
				var el = document.getElementById('seqname');\n\
				var menu = document.getElementById('menu');\n\
				if(el){\n\
					seqname.style.pixelTop=document.body.scrollTop+offsettop;\n\
					menu.style.pixelTop=document.body.scrollTop+offsetmenutop;\n\
				}\n\
			}else if (ns6) {\n\
				var el = document.getElementById('seqname');\n\
				var menu = document.getElementById('menu');\n\
				if(el){\n\
					document.getElementById('seqname').style.top=window.pageYOffset+offsettop;\n\
					document.getElementById('menu').style.top=window.pageYOffset+offsetmenutop;\n\
				}\n\
			}else if (ns4) {\n\
				eval(document.seqname.top=eval(window.pageYOffset+offsettop));\n\
			}\n\
		}\n\
	}\n\
	\n\
	document.onload= menu3();\n\
	</script>\n\
	<style>\n\
	div.top{\n\
		position:absolute;\n\
		Z-Index:10;\n\
		width:100%%;\n\
		top: 0px;\n\
		left: 0px;\n\
		background-color:#e5e5e5;\n\
		\n\
	}\n\
	\n\
	div.top a {\n\
		color: #2b8ae9;\n\
		text-decoration: underline;\n\
	}\n\
	\n\
	div.top a:hover {\n\
		color: orange;\n\
	}\n\
	\n\
	</style>\n\
	</head><body id=\"doc\" onload=\"transformXMLData('%d','/viewer.xsl','xmlsrc%d')\">\n",full_name_len,crosslink,full_name_len,crosslink,size,view);
	
}

void print_stylesheet()
{
	fprintf(stdout,"<xml id=\"xslsrc\" style=\"display:none;\">\n");
	
	fprintf(stdout,"<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">\n");
	fprintf(stdout,"<xsl:param name=\"size\" />\n");
	fprintf(stdout,"<xsl:param name=\"namelen\" />\n");
	fprintf(stdout,"<xsl:param name=\"crosslink\" />\n");
	fprintf(stdout,"<xsl:template name=\"main\" match=\"/\">\n");
	//fprintf(stdout,"<html xsl:version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" xmlns=\"http://www.w3.org/1999/xhtml\">\n");
	/*fprintf(stdout,"<!--<head>\n");
	fprintf(stdout,"<style>\n");
	fprintf(stdout,"b{\n");
	fprintf(stdout,"	font-size: 12pt;\n");
	fprintf(stdout,"	font-family: courier;\n");
	fprintf(stdout,"	font-weight: bold;\n");
	fprintf(stdout,"}\n");
	fprintf(stdout,"</style>\n");
	fprintf(stdout,"</head>-->\n");*/
	//fprintf(stdout,"<body style=\"font-family:Sans-serif;margin: 0px;\">\n");

	fprintf(stdout,"<xsl:call-template name=\"screen\"/>\n");

	//fprintf(stdout,"</body>\n");
	//fprintf(stdout,"</html>\n");
	fprintf(stdout,"</xsl:template>\n");

	fprintf(stdout,"<xsl:template match=\"macsim/alignment\" name=\"screen\">\n");
	fprintf(stdout,"<div id=\"seqname\" style=\"Position:absolute; top:76px; left: 0px; Z-Index:5;\">\n");
	fprintf(stdout,"<table style=\"font-size:{$size};background-color:#ffffff;border:thin solid black;\">\n");
	fprintf(stdout,"<tr>\n");
	fprintf(stdout,"<td style=\"padding: 5px 5px;\">\n");
	fprintf(stdout,"<pre>\n");
	fprintf(stdout,"<span style=\"background-color:#98c6ff;font-weight:bold\"><xsl:value-of select=\"macsim/laddername\"/></span><br/>\n");

	fprintf(stdout,"<xsl:apply-templates select=\"macsim/alignment/sequence/seq-name\"/> \n");


	fprintf(stdout,"<span style=\"background-color:#98c6ff;font-weight:bold\"><xsl:value-of select=\"macsim/laddername\"/></span></pre>\n");
	fprintf(stdout,"</td>\n");
	fprintf(stdout,"</tr>\n");
	fprintf(stdout,"</table>");
	fprintf(stdout,"</div>\n");

	fprintf(stdout,"<div style=\"Position:absolute; top:76px; left: 0px; Z-Index:0;\">\n");
	fprintf(stdout," <table style=\"font-size:{$size};background-color:#ffffff;border:thin solid black;\" >\n");
	fprintf(stdout," <tr>\n");
	fprintf(stdout,"<td style=\"padding: 5px 5px;\">\n");
	fprintf(stdout,"<pre>\n");
	fprintf(stdout,"<span style=\"background-color:#98c6ff;font-weight:bold\"><xsl:value-of 	select=\"macsim/laddername\"/></span><br/>\n");
	fprintf(stdout,"<xsl:apply-templates select=\"macsim/alignment/sequence/seq-name\"/> \n");
	fprintf(stdout,"<span style=\"background-color:#98c6ff;font-weight:bold\"><xsl:value-of 	select=\"macsim/laddername\"/></span></pre>\n");
	fprintf(stdout,"</td>\n");
	fprintf(stdout,"<td style=\"padding: 5px 5px;\">\n");
	fprintf(stdout,"<pre>\n");

	fprintf(stdout,"<xsl:apply-templates select=\"macsim/ladder\"/><br/>\n");
	fprintf(stdout,"<xsl:for-each select=\"macsim/alignment/sequence\">\n");
	fprintf(stdout,"	<xsl:apply-templates select=\"seq-data\"/> <br/>\n");
	fprintf(stdout,"</xsl:for-each>\n");
	fprintf(stdout,"<xsl:apply-templates select=\"macsim/ladder\"/><br/>\n");

	fprintf(stdout,"</pre>\n");
	fprintf(stdout,"</td>\n");
	fprintf(stdout,"</tr>\n");
	fprintf(stdout,"</table></div>\n");

	fprintf(stdout,"</xsl:template>\n");

	fprintf(stdout,"<xsl:template match=\"macsim/ladder\" >\n");
	fprintf(stdout,"	<span style=\"background-color:#98c6ff;font-weight:bold\"><xsl:value-of select=\".\"/></span>\n");
	fprintf(stdout,"</xsl:template>\n");

	fprintf(stdout,"<xsl:template match=\"sequence/seq-name\" >\n");

	fprintf(stdout,"<xsl:if test='contains($crosslink, \"http\")'>\n");
	fprintf(stdout,"<b>\n");
	fprintf(stdout,"	<a>\n");
	fprintf(stdout,"	<xsl:attribute name=\"href\"><xsl:value-of select='$crosslink'/>?name=<xsl:value-of select='.'/></xsl:attribute>\n");
	fprintf(stdout,"	<xsl:value-of select='substring(., 0, $namelen)'/>\n");
	fprintf(stdout,"	</a>\n");
	fprintf(stdout,"	</b>\n");
	fprintf(stdout,"	<br/>\n");
	fprintf(stdout,"</xsl:if>\n");
	fprintf(stdout,"<xsl:if   test='not(contains($crosslink, \"http\"))'>\n");
	fprintf(stdout,"<b><xsl:value-of select='substring(., 0, $namelen)'/></b><br/>\n");
	fprintf(stdout,"</xsl:if>\n");

	fprintf(stdout,"<!-- </xsl:when> -->\n");
	fprintf(stdout,"</xsl:template>\n");


	fprintf(stdout,"<xsl:template match=\"seq-data\" >\n");
	fprintf(stdout,"	<b><xsl:apply-templates select=\"g\"/></b>\n");
	fprintf(stdout,"</xsl:template>\n");

	fprintf(stdout,"<xsl:template match=\"g\" >\n");
	fprintf(stdout,"		<span>\n");
	fprintf(stdout,"		<xsl:if test=\"c\">\n");
	fprintf(stdout,"  		<xsl:attribute name=\"style\">background-color:<xsl:value-of select=\"c\"/></xsl:attribute>\n");
	fprintf(stdout,"  		</xsl:if>\n");
	fprintf(stdout,"  		<xsl:if test=\"c1\">\n");
	fprintf(stdout,"  		<xsl:attribute name=\"style\">color:<xsl:value-of select=\"c1\"/></xsl:attribute>\n");
	fprintf(stdout,"  		</xsl:if>\n");
	fprintf(stdout,"  		<xsl:if test=\"t\">\n");
	fprintf(stdout,"  		<xsl:attribute name=\"title\"><xsl:value-of select=\"t\"/></xsl:attribute>\n");
	fprintf(stdout,"  		</xsl:if>\n");
	fprintf(stdout,"  		<xsl:value-of select=\"r\"/>\n");
	fprintf(stdout,"  		</span>\n");
		
	fprintf(stdout,"</xsl:template>\n");

	fprintf(stdout,"</xsl:stylesheet>\n");
	
	fprintf(stdout,"</xml>\n");

}


void viewerbottom(struct alignment* aln,struct parameters* param,int dna)
{
	char * kalign_parameters = param->kalign_parameters;
	int size = param->size;
	int view = param->view;
	int i,j,c;
	double* p = 0;
	char* ann_label[] = {"Color: none","Color: Conservation","Color: Toby","Color: Erik","Hydro.(w = 7)","Hydro.(w = 21)","Color: Rna/Dna","Color: strong DNA","Color: Conservation"};
	int param_pos[4];
	
	for (i =0;i < 4;i++){
		param_pos[i] = -1;
	}
	
	p = get_stat(aln,p);
	fprintf(stdout,"\
	<div id=\"menu\" class=\"top\">\
	<table cellspacing =\"0\" cellpadding=\"0\" border=\"0\" >\
	<tr>\
		<td style=\"background-color:navy;padding:0px 5px;width:100px\">\
		<span style=\"font-weight:bold;color: #fd5f10;font-size: 120%%;\">\
		Kalignvu\
		</span>\
		</td>\
		<form name= \"form0\">\
		<td>\n\
		<select  size=\"1\" name=\"size\" onchange=\"transformXMLData(document.form0.size.value,'/viewer.xsl','');return false;\">\n");
		//fprintf(stdout,"<option value=\"%d\" selected=\"selected\">Size: %d \n",size,size);
		for (i = 4; i < 26;i+=2){
			if (i == size){
				fprintf(stdout,"<option value=\"%d\" selected=\"selected\" >Size: %d\n",i,i);
			}else{
				fprintf(stdout,"<option value=\"%d\"  >Size: %d\n",i,i);
			}
		} 
		fprintf(stdout,"\
		</select>\
		</td>\
		</form>\n\n");
		
		
		fprintf(stdout,"<form name= \"form2\">");
		fprintf(stdout,"<td>");
		
		fprintf(stdout,"<select onchange=\"transformXMLData('','/viewer.xsl',document.form2.view.value);return false;\" name=\"view\">");
		
		c = 0;
 		for (i = 0;i < 10;i++){
			
			if(aln->ann_key[i]){
				if(c == view){
					fprintf(stdout,"<option selected=\"selected\" value=\"xmlsrc%d\">%s",c,ann_label[i]);
					view = -1;
				}else{
					fprintf(stdout,"<option  value=\"xmlsrc%d\">%s",c,ann_label[i]);
				}
				c++;
			}
		}
		for(i = 0; i< aln->numtypes;i++){
			if(c == view){
				fprintf(stdout,"<option selected=\"selected\"  value=\"xmlsrc%d\">View: %s",c,aln->types[i]);
				view = -1;
			}else{
				fprintf(stdout,"<option value=\"xmlsrc%d\">View: %s",c,aln->types[i]);
			}
			c++;
			
		}
		for(i = 0; i< aln->numcolumn;i++){
			if(c == view){
				fprintf(stdout,"<option selected=\"selected\" value=\"xmlsrc%d\">View: %s",c,aln->ca[i]->name);
				view = -1;
			}else{
				fprintf(stdout,"<option value=\"xmlsrc%d\">View: %s",c,aln->ca[i]->name);
			}
			c++;
		}

		fprintf(stdout,"</select>");
		fprintf(stdout,"</td>");
		fprintf(stdout,"</form>");
		
		
		
		fprintf(stdout,"<form method =\"post\" enctype=\"multipart/form-data\" name= \"form1\" action=\"/cgi-bin/viewer.cgi\">\
		<input type=\"hidden\" name=\"xml\" value=\"\"/>\
		<input type=\"hidden\" name=\"size\" value=\"\"/>\
		<input type=\"hidden\" name=\"xmlsrc\" value=\"\"/>\
		<td >\
			<select size=\"1\" name=\"format\"onchange=\"forward1(document.form1.format.value,'xmlsrc0');return false;\">\
			<option value=\"fasta\">Output:\
			<option value=\"fasta\">Output: Fasta\
			<option value=\"msf\">Output: Msf\
			<option value=\"clustal\">Output: ClustalW\
			<option value=\"macsim\">Output: Macsim\
			<option value=\"circulartree\">Output: Circular SVG tree\
			<option value=\"radialtree\">Output: Radial SVG tree\
			</select>\
		</td>\
		</form>");
		
		
	fprintf(stdout,"\
	</tr></table>");
	if(kalign_parameters != 0  && check_identity("no",kalign_parameters)!= -1){
	}else{
	fprintf(stdout,"\
	<table cellspacing =\"0\" cellpadding=\"0\" border=\"0\" style=\"border-top: thin solid #000000\"><tr>\
	<form method =\"post\" enctype=\"multipart/form-data\" name= \"form3\" action=\"http://msa.cgb.ki.se/cgi-bin/msa.cgi\"\
	<td style=\"padding:0px 5px;width:100px\"></td>\
	");
	
	//fprintf(stdout,"<form method =\"post\" enctype=\"multipart/form-data\" name= \"form3\" action=\"/cgi-bin/msa.cgi\">");
	if(!kalign_parameters && !dna){
		fprintf(stdout,"<td>gpo:<input name=\"gpo\" type=\"text\" size=\"2\" value=\"11.0\"></input></td>");
		fprintf(stdout,"<td>gpe:<input name=\"gpe\" type=\"text\" size=\"2\" value=\"0.85\"></input></td>");
		fprintf(stdout,"<td>tgpe:<input name=\"tgpe\" type=\"text\" size=\"2\" value=\"0.45\"></input></td>");
		fprintf(stdout,"<td>bonus:<input name=\"bonus\" type=\"text\" size=\"2\" value=\"0.0\"></input></td>");
	}else if(!kalign_parameters && dna){
		fprintf(stdout,"<td>gpo:<input name=\"gpo\" type=\"text\" size=\"2\" value=\"80.0\"></input></td>");
		fprintf(stdout,"<td>gpe:<input name=\"gpe\" type=\"text\" size=\"2\" value=\"3.0\"></input></td>");
		fprintf(stdout,"<td>tgpe:<input name=\"tgpe\" type=\"text\" size=\"2\" value=\"3.0\"></input></td>");
		fprintf(stdout,"<td>bonus:<input name=\"bonus\" type=\"text\" size=\"2\" value=\"0.0\"></input></td>");
	}else{
		c = 0;
		j = 0;
		//fprintf(stdout,"<td>");
		while(kalign_parameters[c] != 0){
			if(kalign_parameters[c] == '_'){
				kalign_parameters[c] = 0;
			}
			if(kalign_parameters[c] == '='){
				param_pos[j] = c+1;
				j++;
			}
		//	fprintf(stdout,"%d	%c\n",c,kalign_parameters[c]);
			c++;
		}
		//fprintf(stdout,"</td>");
		fprintf(stdout,"<td><span title=\"Gap open penalty\">gpo:</span>");
		if(param_pos[0] != -1){
			fprintf(stdout,"<input name=\"gpo\" type=\"text\" size=\"2\" value=\"%0.1f\"></input></td>",atof(kalign_parameters+param_pos[0]));
		}else{
			fprintf(stdout,"<input name=\"gpo\" type=\"text\" size=\"2\" value=\"6.0\"></input></td>");
		}
		
		fprintf(stdout,"<td><span title=\"Gap extension penalty\">gpe:</span>");
		if(param_pos[1] != -1){
			fprintf(stdout,"<input name=\"gpe\" type=\"text\" size=\"2\" value=\"%0.1f\"></input></td>",atof(kalign_parameters+param_pos[1]));
		}else{
			fprintf(stdout,"<input name=\"gpe\" type=\"text\" size=\"2\" value=\"0.8\"></input></td>");
		}
		
		fprintf(stdout,"<td><span title=\"N/C terminal gap extension penalty\">tgpe:</span>");
		if(param_pos[2] != -1){
			fprintf(stdout,"<input name=\"tgpe\" type=\"text\" size=\"2\" value=\"%0.1f\"></input></td>",atof(kalign_parameters+param_pos[2]));
		}else{
			fprintf(stdout,"<input name=\"tgpe\" type=\"text\" size=\"2\" value=\"0.0\"></input></td>");
		}
		
		fprintf(stdout,"<td><span title=\"Bonus added to all substitution scores\">bonus:</span>");
		if(param_pos[3] != -1){
			fprintf(stdout,"<input name=\"bonus\" type=\"text\" size=\"2\" value=\"%0.1f\"></input></td>",atof(kalign_parameters+param_pos[3]));
		}else{
			fprintf(stdout,"<input name=\"bonus\" type=\"text\" size=\"2\" value=\"0.0\"></input></td>");
		}
	}
		
	fprintf(stdout,"<td><input name=\"inSeq\" type=\"hidden\"  value=\"\"/></td>");
	fprintf(stdout,"<td><input name=\"size\" type=\"hidden\"  value=\"\"/></td>");
	fprintf(stdout,"<td><input name=\"view\" type=\"hidden\"  value=\"\"/></td>");
	fprintf(stdout,"<td><input name=\"mode\" type=\"hidden\" value=\"run_kalign\" /></td>");
	fprintf(stdout,"<td style=\"padding:0px 5px;\">");
	
	fprintf(stdout,"<input size=\"1\" type=\"submit\"/ onclick=\"forward3('xmlsrc0');return false;\" value=\"re-align with Kalign\">");
	
	fprintf(stdout,"</td>");
	fprintf(stdout,"</form>");
	
	fprintf(stdout,"</tr></table>");
	}
	
	fprintf(stdout,"\
	<div style=\"background-color:#a4a4a4;font-size:90%%; border-top:thin solid black;border-bottom:thin solid black;color:#000000;padding: 0px 5px;\">\
	\
	<span title=\"Number of sequences\">Seq.: %d</span><span style=\"color:white\"> | </span>\
	<span title=\"Number of columns\">Col.:%d</span><span style=\"color:white\"> | </span>\
	<span title=\"Average sequence length\">Len.: %d<span><span style=\"color:white\"> | </span>\
	<span title=\"Number of residues in alignment\">Res.: %d<span><span style=\"color:white\"> | </span>\
	<span style=\"color:red\" title=\"Average percentage identity\">Id: %0.0f%%<span><span style=\"color:white\"> | </span>\
	<span style=\"color:red\" title=\"Total number of aligned pairs divided by the maximum number of possible pairs\">Al.: %0.0f%%<span>\
	</div>\
	</div>\
	<div id=\"xslTarget\"></div>\
	\
	\
	</body></html>",aln->numseq,aln->si[0]->sl,(int)p[0],(int)p[3],p[1]*100,p[2]*100);
	free(p);
}

double* get_stat(struct alignment* aln,double* out)
{
	int i,j,c;
	double len = 0.0;
	double sim = 0.0;
	double poar = 0.0;
	double* tmp = 0;
	
	tmp = tmalloc(sizeof(double)*aln->numseq);
	
	for (i = 0; i< aln->numseq;i++){
		tmp[i] = 0.0f;
	}
	
	c = 0;
	out = malloc(sizeof(double)*4);
	
	for (i = 0; i< aln->numseq;i++){
		for (j = 0;j < aln->aln_len;j++){
			if (isalpha(aln->si[i]->s[j])){
				len++;
				tmp[i]++;
			}
 		}
 	}
 	out[3] = len;
 	out[0] = len/(double)aln->numseq;
 	out[1] = 0.0;
 	
 	len = 0.0;
 	for (i = 0; i < aln->numseq-1;i++){
		for (j = i+1;j < aln->numseq;j++){
	//		if(aln->sl[i] > aln->sl[j]){
	//		fprintf(stderr,"%f	%f\n",tmp[i],tmp[j]);
			if(tmp[i]> tmp[j]){
	//			len+= aln->sl[i];
				len+= tmp[j];
			}else{
	//			len+= aln->sl[j];
				len+= tmp[i];
			}
		}
	}
	out[2] = len;
	
	poar = 0;
	for (i = 0; i< aln->numseq;i++){
		for (j = i+1;j < aln->numseq;j++){
			len = 0.0;
			sim = 0.0;
			for (c = 0;c < aln->aln_len;c++){
				if (isalpha(aln->si[i]->s[c])){
					if (isalpha(aln->si[j]->s[c])){
						if (aln->si[i]->s[c] == aln->si[j]->s[c]){
							sim++;
						}
						len++;
						poar++;
					}
				}
			}
			
			if (!len){
				len = 1;
			}
			
			out[1] += sim / len;
		}
	}
	free(tmp);
	out[1] /= (aln->numseq*(aln->numseq-1))/2;
	out[2] = poar/out[2];
	return out;
}

