/*
	phylo.h 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#define FLOATINFTY 100000000000000000000.0
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

int numseq;

struct tnode{
	struct tnode** links;
	struct tnode* left;
	struct tnode* right;
	struct tnode* parent;
	char* label;
	float height;
	float e;
	float x;
	float y;
	double w;
 	double tau;	
 	int labell;
	int size; 
	int leaf;
	int depth;
	int num;
	int deg;
};

float**  get_distances_from_multiple_alignment(struct alignment* aln,float** dm);

struct tnode* dupgma(float **dm, struct alignment* aln);
struct tnode* dnj(float **dm, struct alignment* aln);


 struct tnode* read_phylip_tree(struct tnode* tree,char* string);

void print_ttree(struct tnode* p);
void radial_svg_tree(struct tnode* tree);

void circular_svg_tree(struct tnode* tree);

void free_ttree(struct tnode* p);


void svg_tree_out(struct tnode* p,char* outfile);
void print_svg_tree(struct tnode* p, FILE *fout);
void scale_svg_tree(struct tnode* p);
void find_margin(struct tnode* p);


double sigma;

struct tnode* alloc_node(struct tnode* p,int i);




