/*
	radial_svg_tree.c 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#include "msa_viewer.h"
#include "phylo.h"
#include "svg_tree.h"
#include <math.h>

double l_root = 0.0;

double* c;
double* dx;
double* dy;
double *s;

double i;
double k;


void radial_svg_tree(struct tnode* tree)
{
	
	
	
	//postorder_traversal - done alreagy size holds number of leaves for each subtree... 
	minx = FLOATINFTY;
	maxx = -FLOATINFTY ;

	miny = FLOATINFTY;
	maxy = -FLOATINFTY;
	
	
	l_root = tree->size;
	tree->x = 0.0;
	tree->y = 0.0;
	tree->w = M_PI * 2;
	tree->tau =  0.0;
	
	radial_preorder_traversal(tree);
	

	//fprintf(stderr,"MINX:%f\nMAXX:%f\nMINY:%f\nMAXY:%f\n",minx,maxx,miny,maxy);
}



void radial_preorder_traversal(struct tnode* v)
{
	
	struct tnode* child = 0;
	struct tnode* u = 0;
	int f = 0;
	
	double n = v->tau;
	
	if(v->leaf != -1){
		u = v->parent;
		v->x = u->x + (v->e)* cos(v->tau + v->w/2);
		if(v->x > maxx){
			maxx = v->x;
		}
		
		if(v->x < minx){
			minx = v->x;
		}
		
		
		//fprintf(stderr,"len:%f	cos:%f	%f %f\n",u->height-v->height,v->tau, v->w/2,cos(v->tau + v->w/2));
		v->y = u->y + (v->e)* sin(v->tau + v->w/2);
		
		if(v->y > maxy){
			maxy = v->y;
		}
		
		if(v->y < miny){
			miny = v->y;
		}
		
		//fprintf(stderr,"len:%f	sin:%f	%f %f\n",u->height-v->height,v->tau, v->w/2,sin(v->tau + v->w/2));
	}
	//fprintf(stderr,"N:%f\n",n);
	//left
	
	while(v->links[f]){
		child = v->links[f];
		child->w = (double)child->size/(double)l_root *(double)M_PI*2;
		
		//fprintf(stderr,"w:%f	%f	%f \n",child->w,(double)child->size,l_root);
		child->tau = n;
		n = n + child->w;
		//fprintf(stderr,"N:%f\n",n);
		radial_preorder_traversal(child);
		f++;
	}/*
	if(v->left){
		child = v->left;
		child->w = (double)child->size/(double)l_root *(double)M_PI*2;
		//fprintf(stderr,"w:%f	%f	%f \n",child->w,(double)child->size,l_root);
		child->tau = n;
		n = n + child->w;
		//fprintf(stderr,"N:%f\n",n);
		radial_preorder_traversal(child);
	}
	//right
	if(v->right){
		child = v->right;
		child->w = (double)child->size/(double)l_root *(double)M_PI*2;
		child->tau = n;
		n = n + child->w;
	//	fprintf(stderr,"N:%f\n",n);
		radial_preorder_traversal(child);
	}*/
}

