/*
	svg_output.c 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "msa_viewer.h"
#include "colors.h"
#include "svg_output.h"


void svg_out(struct alignment* aln,int full_name_len,int remove_allgap_columns)
{
	int i,j,x,y,w,oldx;
	int choice = 0;
	int old_choice = 0;
	int* isgap = 0;
	int newlen = 0;
	char* ladder = 0;
	
	
	/*for (j = 0; j< aln->numseq;j++){
		if( aln->si[j]->namel > max){
			max = aln->si[j]->namel;
		}
	}
	if(max > full_name_len){
		max = full_name_len;
	//	for (j = 0; j< aln->numseq;j++){
	//		 aln->si[j]->name[max] = 0;
	//	}
	}*/
	
	
	
	
	isgap = tmalloc(sizeof(int)*aln->aln_len);
	for( i = aln->aln_len;i--;){
		isgap[i] = 1;
	}
	
	if(remove_allgap_columns){
	for (i = 0; i < aln->aln_len;i++){
		for (j = 0; j < aln->numseq;j++){
			if(isalpha((int)aln->si[j]->s[i])){
				isgap[i] = 0; 
				newlen++;
				break;
			}
		}
	}
	}else{
		for( i = aln->aln_len;i--;){
			isgap[i] = 0;
		}
		newlen = aln->aln_len;
	}
	
	ladder = print_ladder(ladder,newlen);
	for (i = 0; i< newlen;i++){
		if (ladder[i] == ' '){
			ladder[i] = '-';
		}
	}
	
	
	fprintf(stdout,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n\
	<!-- Created with Inkscape (http://www.inkscape.org/) -->\n\
	<svg\n\
	   xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n\
	   xmlns:cc=\"http://web.resource.org/cc/\"\n\
	   xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n\
	   xmlns:svg=\"http://www.w3.org/2000/svg\"\n\
	   xmlns=\"http://www.w3.org/2000/svg\"\n\
	   xmlns:xlink=\"http://www.w3.org/2000/xlink/namespace/\"\n\
	   width=\"%d\"\n\
	   height=\"%d\"\n\
	   id=\"svg2\">\n\
	  \n",(aln->aln_len+full_name_len)*12,(aln->numseq+2)*20*3);
	  	  
	x = 0;
	y = 0;
	fprintf(stdout,"<g id=\"layer1\" style=\"font-size:20.0px;font-family:courier;\">\n");
	
	/*for (i = 0;i < aln->numseq;i++){
		for (j = 0;j < aln->aln_len;j++){
			if(!(aln->ann[i][j] & 0xf00) && aln->ann[i][j] ){
				fill_area(aln,i,j,full_name_len*12+12*j,i*20);
			}
		}
	}
	
	//fill_area(aln,0,485,full_name_len*12+12*485,0);
	
	for (i = 0;i < aln->numseq;i++){
		fprintf(stdout,"<text x=\"%d\" y=\"%d\">%s</text>",full_name_len*12,y+15,aln->si[i]->s);
		y += 20;
	}
	//y += 40;
	
	fprintf(stdout,"</g></svg>\n");
	
	exit(0);*/
		
		//TOP LADDER
	fprintf(stdout,"<rect x=\"%d\" y=\"%d\" height=\"20\" width=\"%d\" fill=\"#98c6ff\" />",full_name_len*12,y,(aln->aln_len)*12);
	fprintf(stdout,"<text x=\"%d\" y=\"%d\">%s</text>\n",full_name_len*12,y+15,ladder);
	/*fprintf(stdout,"LADDER");
	for(i = 6; i< full_name_len;i++){
		fprintf(stdout,"_");
	}
	fprintf(stdout,"%s</text>\n",ladder);*/
	y+= 20;

	oldx = 0;
	w = 12;
	for (i = 0;i < aln->numseq;i++){
	//	fprintf(stdout,"<sequence seq-type=\"Protein\"><seq-name>%s</seq-name>\n",aln->sn[i]);
		x = full_name_len*12;
		oldx = full_name_len*12;
		old_choice = -10000;
		
		
		
		//aln->si[i]->name;///kjasgfka 
		
		//fprintf(stdout,"<seq-data><g><r>");
		for (j = 0;j < aln->aln_len;j++){
			if(!isgap[j]){
				/*choice = aln->ann[i][j];
				if(choice){
					fprintf(stdout,"<rect x=\"%d\" y=\"%d\" height=\"20\" width=\"12\" fill=\"%s\" />",x,y,color_options[choice].hex_code);
				}*/
				choice = aln->ann[i][j] & 0xff;
				
				//<path d="M250 150 L150 350 L350 350 Z" />
				
				if (old_choice == choice){
					w += 12;
				}else{
					if (old_choice == -10000){
						old_choice = choice;
					}
					fprintf(stdout,"<rect x=\"%d\" y=\"%d\" height=\"20\" width=\"%d\" fill=\"%s\" />",oldx,y,w,color_options[old_choice].hex_code);
					oldx = x;
					w= 12;
				}
				old_choice = choice;
				
				//fprintf(stdout,"<text x=\"%d\" y=\"%d\">%c</text>\n",x,y+15,aln->si[i]->s[j]);			
								
				x+=12;
			}
			
			
		}
		if (old_choice == -10000){
			old_choice = choice;
		}
		fprintf(stdout,"<rect x=\"%d\" y=\"%d\" height=\"20\" width=\"%d\" fill=\"%s\" />",oldx,y,w,color_options[old_choice].hex_code);
		x = 0;
		fprintf(stdout,"<text x=\"%d\" y=\"%d\">%s</text>",full_name_len*12,y+15,aln->si[i]->s);
		
		
		fprintf(stdout,"<text x=\"%d\" y=\"%d\">",x, y+15);
		if(aln->si[i]->namel > full_name_len){
			for (j = 0; j < full_name_len;j++){
				fprintf(stdout,"%c",aln->si[i]->name[j]);
			}
		}else{
			for (j = 0; j < aln->si[i]->namel;j++){
				fprintf(stdout,"%c",aln->si[i]->name[j]);
			}
		}
		fprintf(stdout,"</text>\n");

		fprintf(stdout,"\n");
		y += 20;
	}
	
	//BOTTOM LADDER
	fprintf(stdout,"<rect x=\"%d\" y=\"%d\" height=\"20\" width=\"%d\" fill=\"#98c6ff\" />",full_name_len*12,y,(aln->aln_len)*12);
	fprintf(stdout,"<text x=\"%d\" y=\"%d\">%s</text>\n",full_name_len*12,y+15,ladder);

	fprintf(stdout,"</g></svg>\n");


	for (i = aln->numseq;i--;){
		free(aln->ann[i]);
	}
	free(aln->ann);
	
	aln->ann =0;
	free_alignment(aln);
	free(isgap);
	free(ladder);
}

