/*
	tree_mem.c 
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#include "msa_viewer.h"
#include "phylo.h"

struct tnode* alloc_node(struct tnode* p,int i)
 {
 	int j;
 	p = malloc(sizeof(struct tnode));
 	p->links = malloc(sizeof(struct tnode*)*i);
	for (j = 0;j < i;j++){
		p->links[j] = 0;
	}
 	p->left = 0;
	p->right = 0;
	p->parent = 0;
	p->label = 0;
		
	p->height = 0.0;
	p->e = 0.0;
	p->x = 0.0;
	p->y = 0.0;
	p->w = 0.0;
	p->tau = 0.0;
	
	p->labell = 0;
	p->leaf = 0;
	p->deg = 0;
	p->size = 0;
	p->depth = 0;
	p->num = 0;
	return p;
 }



void free_ttree(struct tnode* p)
{
	int i = 0;
	
	while(p->links[i]){
		free_ttree(p->links[i]);
		i++;
	}
	
	free(p->links);
	free(p->label);
	
	/*if(p->left){
		free_ttree(p->left);
	}
	if(p->right){
		free_ttree(p->right);
	}*/
	free(p);
}




