#!/usr/bin/perl
use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser);
use IO::File;
use POSIX qw(tmpnam);
use constant BUFFER_SIZE    => 16_384;
 
my $cgidir = "/var/www/cgi-bin";
#my  $cgidir = "/export/web/msa.cgb.ki.se/cgi-bin";
 
my $q = new CGI;

if($q->param('name') ne ""){
	my $name = $q->param('name');
	if($name =~m/[\S]+[_][\S]+/g){
	print "Content-type: text/html\n\n";
	
	print "<html><header><meta http-equiv=\"refresh\" content=\"1;url=http://srs.ebi.ac.uk/srsbin/cgi-bin/wgetz?-id+sessionId+[uniprot-AllText:$name]+-view+UniprotView\">";
	print "</header><body></body><html>";

	#print "<html><header><meta http-equiv=\"refresh\" content=\"1;url=http://www.uniprot.org/entry/$name\">";
	#print "</header><body></body><html>";
	}else{
	print "Content-type: text/html\n\n";
	
	print "<html><header>";
	print "</header><body>NOT found</body><html>";
	}


}elsif($q->param('mode') eq "newview"){
	my $ifile;
	my $colorscheme = $q->param('colorscheme');
	if($q->param('file') ne ""){
		$ifile = &get_file($q->param('file'),"");
	}elsif( $q->param('inSeq') ne ""){
		$ifile = &get_file("",$q->param('inSeq'));
	}
	print "Content-type: text/html\n\n";
	my $input = $q->param('inSeq');
	if ($ifile ne ""){
	#	if($colorscheme eq "conservation"){
			open (PH,"$cgidir/kalignvu  -i $ifile  |");	
	#	}else{
	#		open (PH,"$cgidir/msaviewer  $ifile -c $colorscheme |");	
	#	}
		while(<PH>){
			print "$_";
		}
		close(PH);
	}
}elsif($q->param('xml') ne ""){
	my $text = $q->param('xml');
	my $format = $q->param('format');
	my $file = $q->param('file');
	

	do{$name = tmpnam()} until $fh = IO::File->new($name,O_RDWR|O_CREAT|O_EXCL);
	
#	END {unlink($name) or die "could not unlink $name: $!";}
		
	print $fh "$text";
	close($fh);
	#print "Content-type: text/html\n\n";
	
	#print "$format";
	my $start = 0;
	
	if($format =~m /tree/g){
		$format =~s/tree//g;
		open (PH,"$cgidir/kalignvu -i $name -t -l $format 2>&1  |");
		while(<PH>){
			if($_ =~m /<html/g && $start == 0){
				print "Content-type: text/html\n\n";
				$start = 1;
			}
			if($_ =~m /<\?xml/g && $start == 0){
				print "Content-type: text/xml\n\n";
				$start = 1;
			}
		
			if($start){
				print "$_";
			}
		}
		close(PH);
		
	}else{
	
	
	if($file){
		print "Content-type: plain/text\n\n";
	}else{
		if($format eq "macsim"){
			print "Content-Type: application/xml; charset=iso-8859-1\n\n"
		}else{
			print "Content-type: text/html\n\n\n\n\n";
		}
	}
	
	if(!$file && $format ne "macsim"){
		print "<pre>";
	}
	#print "$text";
	
	open (PH,"$cgidir/kalignvu -r 	$format -i $name  |") or die "Could not execute kalignvu\n";
	while (<PH>){
		print $_;
	}
	close(PH);
	if(!$file  && $format ne "macsim"){
		print "</pre>";
	}
	}
	
	unlink($name) or die "could not unlink $name: $!";

}else{
	print "Content-type: text/html\n\n";
	print "<html><body>";
	print "<h2>Paste your alignment here:</h2>";
	print "<form method=\"POST\"  enctype=\"multipart/form-data\"  name= \"input\">";
	print "<textarea maxlength=\"10\" name=\"inSeq\"cols=60 rows=5>";
	print "</textarea>";
	print "<br/>";
	print "or upload a file:<br>";
	print "<input type=\"file\" name=\"file\" size=\"20\">";
	print "<input type=\"hidden\" name=\"mode\" value=\"newview\">";
	print "<br/>";
	print "<br/>";
	print "<input type=\"submit\" value=\"Submit\">";
	print "<input type=\"reset\">";
	print "</form>";
	print "</body></html>";

}



sub get_file {
	my $dl = $_[0];
	my $txt = $_[1];
	my $name;
	my $fileH;
	do { $name = tmpnam() } until $fileH = IO::File->new($name, O_RDWR|O_CREAT|O_EXCL);
	if ($txt) {
		$fileH->print($txt);  
	}else{
		my $buffer ="";
		while ( read( $dl, $buffer, BUFFER_SIZE ) ) {
			$fileH->print($buffer);
		}
	}
	$fileH->close;
	return $name;
}
