<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="size" />

<xsl:param name="namelen" />

<xsl:param name="crosslink" />


<xsl:template name="main" match="/">

<xsl:call-template name="screen"/>

</xsl:template>

<xsl:template match="macsim/alignment" name="screen">
<div id="seqname" style="Position:absolute; top:76px; left: 0px; Z-Index:5;">
 <table style="font-size:{$size};background-color:#ffffff;border:thin solid black;">
 <tr>
<td style="padding: 5px 5px;">
<pre>
<span style="background-color:#98c6ff;font-weight:bold"><xsl:value-of select="macsim/laddername"/></span><br/>

<xsl:apply-templates select="macsim/alignment/sequence/seq-name"/> 




<span style="background-color:#98c6ff;font-weight:bold"><xsl:value-of select="macsim/laddername"/></span></pre>
</td>
</tr>
</table>
</div>

 <div style="Position:absolute; top:76px; left: 0px; Z-Index:0;">
 <table style="font-size:{$size};background-color:#ffffff;border:thin solid black;" >
 <tr>
<td style="padding: 5px 5px;">
<pre>
<span style="background-color:#98c6ff;font-weight:bold"><xsl:value-of select="macsim/laddername"/></span><br/>
<xsl:apply-templates select="macsim/alignment/sequence/seq-name"/> 
<span style="background-color:#98c6ff;font-weight:bold"><xsl:value-of select="macsim/laddername"/></span></pre>
</td>
<td style="padding: 5px 5px;">
<pre>

<xsl:apply-templates select="macsim/ladder"/><br/>
<xsl:for-each select="macsim/alignment/sequence">
	<xsl:apply-templates select="seq-data"/> <br/>
</xsl:for-each>
<xsl:apply-templates select="macsim/ladder"/><br/>

</pre>
</td>
</tr>
</table></div>

</xsl:template>

<xsl:template match="macsim/ladder" >
	<span style="background-color:#98c6ff;font-weight:bold"><xsl:value-of select="."/></span>
</xsl:template>

<xsl:template match="sequence/seq-name" >

<xsl:if test='contains($crosslink, "http")'>
    <b>
    	<a>
    	<xsl:attribute name="href"><xsl:value-of select='$crosslink'/>?name=<xsl:value-of select='.'/></xsl:attribute>
    	<xsl:value-of select='substring(., 0, $namelen)'/>
    	</a>
    </b>
    <br/>
  </xsl:if>
  <xsl:if   test='not(contains($crosslink, "http"))'>
  <b><xsl:value-of select='substring(., 0, $namelen)'/></b><br/>
  </xsl:if>

<!-- </xsl:when> -->
</xsl:template>


<xsl:template match="seq-data" >
	<b><xsl:apply-templates select="g"/></b>
</xsl:template>

<xsl:template match="g" >
		<span>
		<xsl:if test="c">
  		<xsl:attribute name="style">background-color:<xsl:value-of select="c"/></xsl:attribute>
  		</xsl:if>
  		<xsl:if test="c1">
  		<xsl:attribute name="style">color:<xsl:value-of select="c1"/></xsl:attribute>
  		</xsl:if>
  		<xsl:if test="t">
  		<xsl:attribute name="title"><xsl:value-of select="t"/></xsl:attribute>
  		</xsl:if>
  		<xsl:value-of select="r"/>
  		</span>
		
</xsl:template>

</xsl:stylesheet>
